## rdkit 202503.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18)

project (RDKit)

IF(NOT CMAKE_BUILD_TYPE)
  SET(CMAKE_BUILD_TYPE Release CACHE STRING
      "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
      FORCE)
ENDIF(NOT CMAKE_BUILD_TYPE)

# Enable CTest
include(CTest)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

set(CMAKE_MODULE_PATH
    ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/Code/cmake/Modules/")

add_library(rdkit_base INTERFACE)

option(RDK_BUILD_SWIG_WRAPPERS "build the SWIG wrappers" OFF )
option(RDK_BUILD_PYTHON_WRAPPERS "build the standard python wrappers" ON )
option(RDK_BUILD_COMPRESSED_SUPPLIERS "build in support for compressed MolSuppliers" OFF )
option(RDK_BUILD_INCHI_SUPPORT "build the rdkit inchi wrapper" OFF )
option(RDK_BUILD_AVALON_SUPPORT "install support for the avalon toolkit. Use the variable AVALONTOOLS_DIR to set the location of the source." OFF )
option(RDK_BUILD_PGSQL "build the PostgreSQL cartridge" OFF )
option(RDK_BUILD_RPATH_SUPPORT "build shared libraries using rpath" OFF)
option(RDK_PGSQL_STATIC "statically link rdkit libraries into the PostgreSQL cartridge" ON )
option(RDK_PGSQL_BFP_GIST_SORTSUPPORT "enable the sortsupport method in the PostgreSQL bfp gist index" OFF )
option(RDK_PGSQL_MOL_GIST_SORTSUPPORT "enable the sortsupport method in the PostgreSQL mol gist index" ON )
option(RDK_PGSQL_QMOL_GIST_SORTSUPPORT "enable the sortsupport method in the PostgreSQL qmol gist index" ON )
option(RDK_BUILD_CONTRIB "build the Contrib directory" OFF )
option(RDK_INSTALL_INTREE "install the rdkit in the source tree (former behavior)" ON )
option(RDK_INSTALL_DLLS_MSVC "install the rdkit DLLs when using MSVC" OFF)
option(RDK_INSTALL_STATIC_LIBS "install the rdkit static libraries" ON )
option(RDK_INSTALL_PYTHON_TESTS "install the rdkit Python tests with the wrappers" OFF )
option(RDK_BUILD_THREADSAFE_SSS "enable thread-safe substructure searching" ON )
option(RDK_BUILD_SLN_SUPPORT "include support for the SLN format" ON )
option(RDK_TEST_MULTITHREADED "run some tests of multithreading" ON )
option(RDK_BUILD_SWIG_JAVA_WRAPPER "build the SWIG JAVA wrappers (does nothing if RDK_BUILD_SWIG_WRAPPERS is not set)" ON )
option(RDK_BUILD_SWIG_CSHARP_WRAPPER "build the experimental SWIG C# wrappers (does nothing if RDK_BUILD_SWIG_WRAPPERS is not set)" OFF )
option(RDK_BUILD_DOTNET_CSHARP_TESTS "build the DotNet Core tests for C# wrappers on Linux (does nothing if RDK_BUILD_SWIG_CSHARP_WRAPPER is not set and is ignored on Windows)" OFF )
option(RDK_SWIG_STATIC "statically link rdkit libraries into the SWIG wrappers" ON )
option(RDK_TEST_MMFF_COMPLIANCE "run MMFF compliance tests (requires tar/gzip)" ON )
option(RDK_BUILD_CPP_TESTS "build the c++ tests (disabing can speed up builds" ON)
option(RDK_USE_FLEXBISON "use flex/bison, if available, to build the SMILES/SMARTS/SLN parsers" OFF)
option(RDK_TEST_COVERAGE "Use G(L)COV to compute test coverage" OFF)
option(RDK_USE_BOOST_SERIALIZATION "Use the boost serialization library if available" ON)
option(RDK_USE_BOOST_STACKTRACE "use boost::stacktrace to do more verbose invariant output (linux only)" ON)
option(RDK_BUILD_TEST_GZIP "Build the gzip'd stream test" OFF)
option(RDK_OPTIMIZE_POPCNT "Use SSE4.2 popcount instruction while compiling." ON)
option(RDK_USE_STRICT_ROTOR_DEFINITION "Use the most strict rotatable bond definition" ON)
option(RDK_BUILD_DESCRIPTORS3D "Build the 3D descriptors calculators, requires Eigen3 to be installed" ON)
option(RDK_BUILD_FREESASA_SUPPORT "build the rdkit freesasa wrapper" OFF )
option(RDK_BUILD_COORDGEN_SUPPORT "build the rdkit coordgen wrapper" ON )
option(RDK_BUILD_MAEPARSER_SUPPORT "build the rdkit MAE parser wrapper" ON )
option(RDK_BUILD_MOLINTERCHANGE_SUPPORT "build in support for CommonChem molecule interchange" ON )
option(RDK_BUILD_YAEHMOP_SUPPORT "build support for the YAeHMOP wrapper" OFF)
option(RDK_BUILD_XYZ2MOL_SUPPORT "build in support for the RDKit's implementation of xyz2mol (in the DetermineBonds library)" OFF )
option(RDK_BUILD_STRUCTCHECKER_SUPPORT "build in support for the StructChecker alpha (not recommended, use the MolVS integration instead)" OFF )
option(RDK_BUILD_PUBCHEMSHAPE_SUPPORT "build the rdkit wrapper around pubchem-align3d" ON )
option(RDK_USE_URF "Build support for Florian Flachsenberg's URF library" ON)
option(RDK_INSTALL_DEV_COMPONENT "install libraries and headers" ON)
option(RDK_USE_BOOST_IOSTREAMS "use boost::iostreams" ON)
option(RDK_BUILD_MINIMAL_LIB "build the minimal RDKit wrapper (for the JS bindings)" OFF)
option(RDK_MINIMAL_LIB_SUPPORT_LEGACY_BROWSERS "build the minimal RDKit JS wrapper such that it supports legacy browsers" OFF)
option(RDK_BUILD_CFFI_LIB "build the CFFI wrapper (for use in other programming languges)" OFF)
option(RDK_CFFI_STATIC "statically link rdkit libraries into the cffi wrapper" ON)
option(RDK_BUILD_FUZZ_TARGETS "build the fuzz targets" OFF)
option(RDK_BUILD_MINIMAL_LIB_RXN "build support for reactions into MinimalLib" ON )
option(RDK_BUILD_MINIMAL_LIB_SUBSTRUCTLIBRARY "build support for SubstructLibrary into MinimalLib" ON )
option(RDK_BUILD_MINIMAL_LIB_MCS "build support for MCS into MinimalLib" OFF )
option(RDK_BUILD_MINIMAL_LIB_MOLZIP "build support for molzip into MinimalLib" OFF )
option(RDK_BUILD_LONG_RUNNING_TESTS "build longer running tests" OFF )

set(RDK_BOOST_VERSION "1.70.0")

if(NOT MSVC)
  if(RDK_OPTIMIZE_POPCNT)
    if(CMAKE_SYSTEM_PROCESSOR MATCHES "^(aarch64|arm64)")
      message("RDK_OPTIMIZE_POPCNT is not available on aarch64 or arm64")
    elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "^(ppc64|powerpc64)")
      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mpopcntd")
    else()
      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mpopcnt")
    endif()
  endif()
endif()

if(NOT UNIX OR APPLE OR CYGWIN)
  if(RDK_USE_BOOST_STACKTRACE)
    MESSAGE("Disabling boost::stacktrace on non-linux platform")
    set(RDK_USE_BOOST_STACKTRACE OFF)
  endif(RDK_USE_BOOST_STACKTRACE)
endif()

if(NOT RDK_BUILD_SWIG_WRAPPERS)
  set(RDK_BUILD_SWIG_JAVA_WRAPPER OFF)
  set(RDK_BUILD_SWIG_CSHARP_WRAPPER OFF)
endif()

if(RDK_SWIG_STATIC AND RDK_BUILD_SWIG_WRAPPERS)
  if(NOT MSVC AND NOT RDK_INSTALL_STATIC_LIBS)
    message("Enabling RDK_INSTALL_STATIC_LIBS because RDK_SWIG_STATIC is set.")
    set(RDK_INSTALL_STATIC_LIBS ON CACHE BOOL "install the rdkit static libraries" FORCE)
  endif(NOT MSVC AND NOT RDK_INSTALL_STATIC_LIBS)
endif()

if((NOT (MSVC AND (NOT RDK_INSTALL_DLLS_MSVC))) AND NOT (WIN32 AND RDK_INSTALL_STATIC_LIBS))
  add_definitions(-DRDKIT_DYN_LINK)
endif()

if(RDK_PGSQL_STATIC AND RDK_BUILD_PGSQL)
  if(NOT MSVC AND NOT RDK_INSTALL_STATIC_LIBS)
    message("Enabling RDK_INSTALL_STATIC_LIBS because RDK_PGSQL_STATIC is set.")
    set(RDK_INSTALL_STATIC_LIBS ON CACHE BOOL "install the rdkit static libraries" FORCE)
  endif(NOT MSVC AND NOT RDK_INSTALL_STATIC_LIBS)
endif()

if(RDK_CFFI_STATIC AND RDK_BUILD_CFFI_LIB)
  if(NOT MSVC AND NOT RDK_INSTALL_STATIC_LIBS)
    message("Enabling RDK_INSTALL_STATIC_LIBS because RDK_CFFI_STATIC is set.")
    set(RDK_INSTALL_STATIC_LIBS ON CACHE BOOL "install the rdkit static libraries" FORCE)
  endif(NOT MSVC AND NOT RDK_INSTALL_STATIC_LIBS)
endif()


include(TestBigEndian)
TEST_BIG_ENDIAN(RDK_BIG_ENDIAN)

# At build time put runtime binaries in the bin subdirectory
set(RDK_RUNTIME_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/bin")
set(RDK_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/lib")
set(RDK_ARCHIVE_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/lib")
# Also place the python extension where the source tree would expect them
set(RDK_PYTHON_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/rdkit")

#-------
# Config variables:
set(RDKit_Year "2025")
set(RDKit_Month "03")
set(RDKit_Revision "1")
set(RDKit_RevisionModifier "")
set(RDKit_ABI "1")

# we need an integer version of the month later, so remove the zero padding
# if there is any
string(REGEX REPLACE "^0" "" RDKit_intMonth ${RDKit_Month} )

set(RDKit_CodeDir "${CMAKE_CURRENT_SOURCE_DIR}/Code")
set(RDKit_ExternalDir "${CMAKE_CURRENT_SOURCE_DIR}/External")
set(RDKit_DataDir "${CMAKE_CURRENT_SOURCE_DIR}/Data")

#include catch
find_package(Catch2 3 QUIET)
if(NOT Catch2_FOUND)
  Include(FetchContent)

  FetchContent_Declare(
    Catch2
    GIT_REPOSITORY https://github.com/catchorg/Catch2.git
    GIT_TAG        v3.4.0 # or a later release
  )

  FetchContent_MakeAvailable(Catch2)
endif()

#include better-enums
find_package(better_enums 0 QUIET)
if(NOT better_enums)
  Include(FetchContent)

  FetchContent_Declare(
    better_enums
    GIT_REPOSITORY https://github.com/aantron/better-enums.git
    GIT_TAG        c35576bed0295689540b39873126129adfa0b4c8 # 0.11.3
  )
endif()

if(RDK_INSTALL_INTREE)
  set(RDKit_BinDir "${CMAKE_SOURCE_DIR}/bin")
  set(RDKit_LibDir "${CMAKE_SOURCE_DIR}/lib")
  set(RDKit_HdrDir "Code") # used in rdkit-config.cmake, path prefix not needed.
  set(RDKit_ShareDir "${CMAKE_SOURCE_DIR}")
else(RDK_INSTALL_INTREE)
  set(RDKit_BinDir "bin")
  set(RDKit_LibDir "lib${LIB_SUFFIX}")
  set(RDKit_HdrDir "include/rdkit")
  set(RDKit_ShareDir "share/RDKit")
endif(RDK_INSTALL_INTREE)

if(RDK_BUILD_RPATH_SUPPORT)
  # use, i.e. don't skip the full RPATH for the build tree
  SET(CMAKE_SKIP_BUILD_RPATH  FALSE)

  # when building, don't use the install RPATH already
  # (but later on when installing)
  SET(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)

  message("CMAKE_INSTALL_RPATH ${CMAKE_INSTALL_PREFIX}/lib")
  SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")

  # add the automatically determined parts of the RPATH
  # which point to directories outside the build tree to the install RPATH
  SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)

  # the RPATH to be used when installing, but only if it's not a system
  # directory
  LIST(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES
  "${CMAKE_INSTALL_PREFIX}/lib" isSystemDir)
  IF("${isSystemDir}" STREQUAL "-1")
     SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
  ENDIF("${isSystemDir}" STREQUAL "-1")
endif()



if(RDK_BUILD_SWIG_WRAPPERS)
  set(RDKit_JavaLibDir "${RDKit_ExternalDir}/java_lib")
endif(RDK_BUILD_SWIG_WRAPPERS)


if(RDK_BUILD_COORDGEN_SUPPORT)
    add_definitions(-DRDK_BUILD_COORDGEN_SUPPORT)
    include_directories(${RDKit_ExternalDir})
endif()

if(RDK_BUILD_MAEPARSER_SUPPORT)
    add_definitions(-DRDK_BUILD_MAEPARSER_SUPPORT)
    include_directories(${RDKit_ExternalDir})
endif()

if(RDK_USE_URF)
  add_definitions(-DRDK_USE_URF)
  if((MSVC AND (NOT RDK_INSTALL_DLLS_MSVC)) OR ((NOT MSVC) AND WIN32 AND RDK_INSTALL_STATIC_LIBS))
    add_definitions(-DRDL_WIN_STATIC)
  endif()
  include_directories(${RDKit_ExternalDir}/RingFamilies/RingDecomposerLib/src/RingDecomposerLib)
endif()

if(RDK_BUILD_XYZ2MOL_SUPPORT)
    add_definitions(-DRDK_BUILD_XYZ2MOL_SUPPORT)
    include_directories(${RDKit_ExternalDir})
endif()

if(RDK_BUILD_YAEHMOP_SUPPORT)
    add_definitions(-DRDK_BUILD_YAEHMOP_SUPPORT)
endif()

# Detect clang, which masquerades as gcc.  CMake 2.6 doesn't know how to
# detect it.
string(REGEX MATCH "clang" CMAKE_COMPILER_IS_CLANG "${CMAKE_C_COMPILER}")
# Detect emcc
string(REGEX MATCH "Emscripten" CMAKE_COMPILER_IS_EMCC "${CMAKE_SYSTEM_NAME}")

if(CMAKE_SIZEOF_VOID_P EQUAL 4)
  target_compile_definitions(rdkit_base INTERFACE "-DRDK_32BIT_BUILD")
else()
  target_compile_definitions(rdkit_base INTERFACE "-DRDK_64BIT_BUILD")
endif()

if(MINGW)
  target_compile_definitions(rdkit_base INTERFACE "-DBOOST_SYSTEM_NO_DEPRECATED")
endif(MINGW)
if (CMAKE_COMPILER_IS_CLANG OR CMAKE_COMPILER_IS_EMCC)
  if (CMAKE_CXX_COMPILER_VERSION VERSION_GREATER_EQUAL 15)
    target_compile_definitions(rdkit_base INTERFACE -DBOOST_SYSTEM_NO_DEPRECATED -DBOOST_NO_CXX98_FUNCTION_BASE -D_HAS_AUTO_PTR_ETC=0)
    target_compile_options(rdkit_base INTERFACE -Wno-deprecated-builtins -Wno-deprecated-non-prototype -Wno-unused-parameter)
  endif()
endif()

# defines macros: rdkit_python_extension, rdkit_test
include(RDKitUtils)

=== Code/CMakeLists.txt ===
createExportTestHeaders()
add_subdirectory(RDGeneral)
if(RDK_BUILD_PYTHON_WRAPPERS)
  add_subdirectory(RDBoost)
endif(RDK_BUILD_PYTHON_WRAPPERS)
add_subdirectory(RDStreams)
add_subdirectory(DataStructs)
add_subdirectory(Geometry)

add_subdirectory(Numerics)
add_subdirectory(ForceField)
add_subdirectory(DistGeom)
add_subdirectory(Catalogs)

add_subdirectory(GraphMol)
add_subdirectory(Query)
add_subdirectory(Features)

add_subdirectory(DataManip)
if(RDK_BIG_ENDIAN)
  message("Skipping build of SimDivPickers on big endian system")
else(RDK_BIG_ENDIAN)
  add_subdirectory(SimDivPickers)
endif(RDK_BIG_ENDIAN)

add_subdirectory(ML)
add_subdirectory(ChemicalFeatures)

if(RDK_BUILD_SWIG_WRAPPERS)
  add_subdirectory(JavaWrappers)
endif()

if(RDK_BUILD_PGSQL)
  add_subdirectory(PgSQL/rdkit)
endif(RDK_BUILD_PGSQL)

add_subdirectory(MinimalLib)


if(RDK_BUILD_FUZZ_TARGETS)
  add_subdirectory(Fuzz)
endif(RDK_BUILD_FUZZ_TARGETS)

=== Contrib/CMakeLists.txt ===

add_subdirectory(ConformerParser)

=== External/CMakeLists.txt ===
add_subdirectory(INCHI-API)
add_subdirectory(AvalonTools)
add_subdirectory(FreeSASA)
add_subdirectory(CoordGen)
add_subdirectory(YAeHMOP)
add_subdirectory(RingFamilies)
add_subdirectory(GA)
if(RDK_BUILD_PUBCHEMSHAPE_SUPPORT)
add_subdirectory(pubchem_shape)
endif()

=== Projects/CMakeLists.txt ===
add_pythonpytest(pythonProjectTests ${CMAKE_CURRENT_SOURCE_DIR} )

=== Code/Catalogs/CMakeLists.txt ===

rdkit_library(Catalogs 
              Catalog.cpp CatalogParams.cpp CatalogEntry.cpp
              LINK_LIBRARIES RDGeneral)
target_compile_definitions(Catalogs PRIVATE RDKIT_CATALOGS_BUILD)

rdkit_headers(CatalogEntry.h
              Catalog.h
              CatalogParams.h DEST Catalogs)

=== Code/DataStructs/CMakeLists.txt ===
if(RDK_OPTIMIZE_POPCNT)
  ADD_DEFINITIONS("-DRDK_OPTIMIZE_POPCNT")
endif()


rdkit_library(DataStructs
              BitVect.cpp SparseBitVect.cpp ExplicitBitVect.cpp Utils.cpp
              base64.cpp BitOps.cpp DiscreteDistMat.cpp
              DiscreteValueVect.cpp FPBReader.cpp MultiFPBReader.cpp
              RealValueVect.cpp
              LINK_LIBRARIES RDGeneral)
target_compile_definitions(DataStructs PRIVATE RDKIT_DATASTRUCTS_BUILD)

rdkit_headers(base64.h
              BitOps.h
              BitVect.h
              BitVects.h
              BitVectUtils.h
              DatastructsException.h
              DatastructsStreamOps.h
              DiscreteDistMat.h
              DiscreteValueVect.h
              RealValueVect.h
              ExplicitBitVect.h
              SparseBitVect.h
              SparseIntVect.h
              FPBReader.h
              MultiFPBReader.h
              DEST DataStructs)

rdkit_test(testDataStructs testDatastructs.cpp
           LINK_LIBRARIES DataStructs )

rdkit_test(testFPB testFPB.cpp
           LINK_LIBRARIES DataStructs )

rdkit_test(testMultiFPB testMultiFPB.cpp
           LINK_LIBRARIES DataStructs )

rdkit_catch_test(catchDataStructs catch_tests.cpp
           LINK_LIBRARIES DataStructs )

if(RDK_BUILD_PYTHON_WRAPPERS)
add_subdirectory(Wrap)
endif()

=== Code/DistGeom/CMakeLists.txt ===
### ISSUE: This library was originally named DistGeom. I've renamed it here
### to avoid a target name clash in ./Wrap

rdkit_library(DistGeometry
              DistGeomUtils.cpp TriangleSmooth.cpp DistViolationContribs.cpp 
              ChiralViolationContribs.cpp
              LINK_LIBRARIES EigenSolvers ForceField ForceFieldHelpers)
target_compile_definitions(DistGeometry PRIVATE RDKIT_DISTGEOMETRY_BUILD)

rdkit_headers(BoundsMatrix.h
              ChiralSet.h
              ChiralViolationContribs.h
              DistGeomUtils.h
              DistViolationContribs.h
              FourthDimContribs.h
              TriangleSmooth.h DEST DistGeom)

rdkit_test(testDistGeom testDistGeom.cpp 
LINK_LIBRARIES DistGeometry )

if(RDK_BUILD_PYTHON_WRAPPERS)
add_subdirectory(Wrap)
endif()

=== Code/Features/CMakeLists.txt ===
rdkit_headers(Feature.h
              DEST Features)

rdkit_test(testBaseFeatures testFeatures.cpp 
LINK_LIBRARIES RDGeneral RDGeometryLib )

=== Code/Fuzz/CMakeLists.txt ===
if(NOT LIB_FUZZING_ENGINE)
  message("LIB_FUZZING_ENGINE is not set, using standalone fuzz runner, no actual fuzzing will be done!")
  add_library(standalone_fuzz_runner STATIC standalone_fuzz_target_runner.cpp)
  set(LIB_FUZZING_ENGINE standalone_fuzz_runner)
endif()

if(NOT RDK_INSTALL_STATIC_LIBS OR NOT Boost_USE_STATIC_LIBS)
  message(SEND_ERROR "Fuzzing requires static linking!")
  message(FATAL_ERROR "Compile with -DRDK_INSTALL_STATIC_LIBS=ON and -DBoost_USE_STATIC_LIBS=ON")
endif()

include_directories ( "include" )

set(RDKit_LIBS
           ChemReactions_static FileParsers_static SmilesParse_static Depictor_static
           RDGeometryLib_static RDGeneral_static SubstructMatch_static Subgraphs_static
           MolDraw2D_static GraphMol_static RingDecomposerLib_static DistGeometry_static
           DistGeomHelpers_static MolAlign_static Optimizer_static ForceField_static
           ForceFieldHelpers_static Alignment_static ForceField_static MolTransforms_static
           EigenSolvers_static ForceFieldHelpers_static Alignment_static MolTransforms_static
           EigenSolvers_static
)

macro(fuzzer name)
  add_executable(${name} ${name}.cc)
  target_link_libraries(${name} rdkit_base ${RDKit_LIBS} ${LIB_FUZZING_ENGINE})
endmacro()

fuzzer(smiles_string_to_mol_fuzzer)
fuzzer(mol_data_stream_to_mol_fuzzer)
fuzzer(mol_deserialization_fuzzer)

=== Code/Geometry/CMakeLists.txt ===

rdkit_library(RDGeometryLib 
              point.cpp Transform2D.cpp Transform3D.cpp 
              UniformGrid3D.cpp UniformRealValueGrid3D.cpp
              GridUtils.cpp
              LINK_LIBRARIES DataStructs RDGeneral)
target_compile_definitions(RDGeometryLib PRIVATE RDKIT_RDGEOMETRYLIB_BUILD)

rdkit_headers(Grid3D.h
              GridUtils.h
              point.h
              Transform2D.h
              Transform3D.h
              Transform.h
              UniformGrid3D.h
              UniformRealValueGrid3D.h
              Utils.h DEST Geometry)

rdkit_test(testTransforms testTransforms.cpp LINK_LIBRARIES RDGeometryLib )
rdkit_test(testGrid testGrid.cpp LINK_LIBRARIES RDGeometryLib)
rdkit_test(testRealValueGrid testRealValueGrid.cpp LINK_LIBRARIES RDGeometryLib DataStructs RDGeneral)
rdkit_catch_test(geometryTestsCatch catch_tests.cpp
           LINK_LIBRARIES RDGeometryLib)


if(RDK_BUILD_PYTHON_WRAPPERS)
add_subdirectory(Wrap)
endif()

=== Code/GraphMol/CMakeLists.txt ===
rdkit_library(GraphMol
        Atom.cpp QueryAtom.cpp QueryBond.cpp Bond.cpp
        MolOps.cpp FindRings.cpp ROMol.cpp RWMol.cpp PeriodicTable.cpp
        atomic_data.cpp QueryOps.cpp MolPickler.cpp Canon.cpp
        AtomIterators.cpp BondIterators.cpp Aromaticity.cpp Kekulize.cpp
        ConjugHybrid.cpp AddHs.cpp
        Matrices.cpp Chirality.cpp RingInfo.cpp Conformer.cpp
        Renumber.cpp AdjustQuery.cpp Resonance.cpp StereoGroup.cpp
        new_canon.cpp SubstanceGroup.cpp FindStereo.cpp MonomerInfo.cpp
        NontetrahedralStereo.cpp Atropisomers.cpp
        WedgeBonds.cpp MolProps.cpp
        SHARED
        LINK_LIBRARIES RDGeometryLib RDGeneral)
target_compile_definitions(GraphMol PRIVATE RDKIT_GRAPHMOL_BUILD)
if (RDK_USE_URF)
    target_link_libraries(GraphMol PUBLIC ${RDK_URF_LIBS})
    if (NOT WIN32 AND RDK_INSTALL_STATIC_LIBS)
        target_link_libraries(GraphMol_static PUBLIC ${RDK_URF_LIBS}_static)
    endif ()
endif ()

rdkit_headers(Atom.h
        atomic_data.h
        AtomIterators.h
        Atropisomers.h
        Bond.h
        BondIterators.h
        Canon.h
        Chirality.h
        Conformer.h
        details.h
        GraphMol.h
        MolOps.h
        MolPickler.h
        PeriodicTable.h
        QueryAtom.h
        QueryBond.h
        QueryOps.h
        RDKitBase.h
        RDKitQueries.h
        Resonance.h
        RingInfo.h
        Rings.h
        ROMol.h
        RWMol.h
        SanitException.h
        SubstanceGroup.h
        StereoGroup.h
        MonomerInfo.h
        new_canon.h
        MolBundle.h
        DEST GraphMol)

add_subdirectory(SmilesParse)
add_subdirectory(Depictor)
add_subdirectory(MarvinParse)
add_subdirectory(FileParsers)
add_subdirectory(Substruct)
add_subdirectory(GenericGroups)
add_subdirectory(ChemReactions)
add_subdirectory(ChemTransforms)
add_subdirectory(TautomerQuery)

add_subdirectory(Subgraphs)
add_subdirectory(FilterCatalog)
add_subdirectory(FragCatalog)
add_subdirectory(Descriptors)

add_subdirectory(Fingerprints)
add_subdirectory(PartialCharges)

add_subdirectory(MolTransforms)
add_subdirectory(ForceFieldHelpers)
add_subdirectory(DistGeomHelpers)

add_subdirectory(MolAlign)
add_subdirectory(MolChemicalFeatures)
add_subdirectory(ShapeHelpers)
add_subdirectory(MolCatalog)

add_subdirectory(MolDraw2D)

add_subdirectory(FMCS)
add_subdirectory(MolHash)
add_subdirectory(MMPA)
add_subdirectory(RascalMCES)
add_subdirectory(SynthonSpaceSearch)

add_subdirectory(CIPLabeler)
add_subdirectory(Deprotect)

if (RDK_BUILD_STRUCTCHECKER_SUPPORT)
    add_subdirectory(StructChecker)
endif ()

add_subdirectory(ReducedGraphs)
add_subdirectory(Trajectory)

add_subdirectory(SubstructLibrary)
add_subdirectory(RGroupDecomposition)

if (RDK_BUILD_XYZ2MOL_SUPPORT)
    add_subdirectory(DetermineBonds)
endif ()

if (RDK_BUILD_MOLINTERCHANGE_SUPPORT)
    add_subdirectory(MolInterchange)
endif (RDK_BUILD_MOLINTERCHANGE_SUPPORT)

if (RDK_BUILD_SLN_SUPPORT AND NOT CMAKE_COMPILER_IS_CLANG)
    if (CMAKE_COMPILER_IS_GNUCC AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS_EQUAL 4.8)
        message("Skipping SLN build with gcc version <= 4.8")
    else ()
        add_subdirectory(SLNParse)
    endif ()
endif ()

if (RDK_BUILD_PYTHON_WRAPPERS)
    add_subdirectory(Wrap)
endif ()

add_subdirectory(MolStandardize)
add_subdirectory(ScaffoldNetwork)
add_subdirectory(MolEnumerator)
add_subdirectory(Abbreviations)
add_subdirectory(GeneralizedSubstruct)
add_subdirectory(MolProcessing)
add_subdirectory(MolInteractionFields)


rdkit_test(graphmolTest1 test1.cpp LINK_LIBRARIES FileParsers SmilesParse GraphMol
        SubstructMatch ForceFieldHelpers ForceField)

rdkit_test(graphmolcpTest cptest.cpp LINK_LIBRARIES SmilesParse GraphMol)

rdkit_test(graphmolqueryTest querytest.cpp LINK_LIBRARIES SubstructMatch SmilesParse GraphMol)

rdkit_test(graphmolMolOpsTest molopstest.cpp
        LINK_LIBRARIES SubstructMatch FileParsers
        SmilesParse GraphMol)

rdkit_test(graphmoltestChirality testChirality.cpp
        LINK_LIBRARIES SmilesParse FileParsers
        GraphMol)

rdkit_test(graphmoltestPickler testPickler.cpp
        LINK_LIBRARIES SmilesParse SubstructMatch FileParsers GraphMol)

rdkit_test(graphmoltestPicklerGlobalSetting testPicklerGlobalSettings.cpp
        LINK_LIBRARIES SmilesParse SubstructMatch FileParsers GraphMol)

rdkit_test(graphmolIterTest itertest.cpp LINK_LIBRARIES SmilesParse GraphMol)

rdkit_test(hanoiTest hanoitest.cpp LINK_LIBRARIES
        SubstructMatch SmilesParse FileParsers GraphMol
)

rdkit_test(graphmolMemTest1 memtest1.cpp LINK_LIBRARIES SmilesParse GraphMol)

rdkit_test(resMolSupplierTest resMolSupplierTest.cpp
        LINK_LIBRARIES SmilesParse GraphMol SubstructMatch FileParsers)

rdkit_test(molBundleTest testMolBundle.cpp
        LINK_LIBRARIES SmilesParse GraphMol SubstructMatch FileParsers)

rdkit_test(testSGroup testSGroup.cpp LINK_LIBRARIES FileParsers GraphMol)

rdkit_test(test-valgrind test-valgrind.cpp LINK_LIBRARIES SmilesParse FileParsers GraphMol)

rdkit_catch_test(graphmolTestsCatch catch_graphmol.cpp
        LINK_LIBRARIES SubstructMatch FileParsers SmilesParse GraphMol)

rdkit_catch_test(graphmolOrganometallicsCatch catch_organometallics.cpp
        LINK_LIBRARIES FileParsers SmilesParse GraphMol)

rdkit_catch_test(graphmolSGroupCatch catch_sgroups.cpp
        LINK_LIBRARIES SmilesParse FileParsers GraphMol)

rdkit_catch_test(graphmolAdjustQueryCatch catch_adjustquery.cpp
        LINK_LIBRARIES SubstructMatch FileParsers SmilesParse GraphMol)

rdkit_catch_test(chiralityTestsCatch catch_chirality.cpp
        LINK_LIBRARIES CIPLabeler FileParsers SmilesParse GraphMol)

rdkit_catch_test(canonTestsCatch catch_canon.cpp
        LINK_LIBRARIES FileParsers SmilesParse GraphMol)

rdkit_catch_test(moliteratorTestsCatch catch_moliterators.cpp
        LINK_LIBRARIES SubstructMatch SmilesParse GraphMol)

rdkit_catch_test(queryTestsCatch catch_queries.cpp
        LINK_LIBRARIES SmilesParse GraphMol)

rdkit_catch_test(molbundleTestsCatch catch_molbundle.cpp
        LINK_LIBRARIES SmilesParse GraphMol)

rdkit_catch_test(pickleTestsCatch catch_pickles.cpp
        LINK_LIBRARIES FileParsers SmilesParse GraphMol)

rdkit_catch_test(tableTestsCatch catch_periodictable.cpp
        LINK_LIBRARIES GraphMol)

rdkit_catch_test(molopsTestsCatch catch_molops.cpp
        LINK_LIBRARIES FileParsers SmilesParse GraphMol)

=== debian/changelog ===
rdkit (202503.1-5) unstable; urgency=medium

  [ Roland Mas ]
  * Add myself to Uploaders.
  * Enable building of XYZ2MOL support, to get rdDetermineBonds module.
  * Remove another pycache dir from binary package.

 -- Andrius Merkys <merkys@debian.org>  Wed, 13 Aug 2025 08:07:31 -0400

rdkit (202503.1-4) unstable; urgency=medium

  * Update debian/control.in according to debian/control (Closes: #1104363)

 -- Andrius Merkys <merkys@debian.org>  Tue, 29 Apr 2025 09:27:17 -0400

rdkit (202503.1-3) unstable; urgency=medium

  * debian/control: Added Breaks on coot (<< 1.1.15+dfsg-1) for librdkit1t64.

 -- Michael Banck <mbanck@debian.org>  Fri, 25 Apr 2025 08:53:17 +0200

rdkit (202503.1-2) unstable; urgency=medium

  * debian/patches/disable_riscv64_timeout_tests.patch: Add one more test which
    times out on riscv64.

 -- Michael Banck <mbanck@debian.org>  Mon, 07 Apr 2025 16:22:36 +0200

rdkit (202503.1-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches/disable_riscv64_timeout_tests.patch: Refreshed.
  * debian/patches/better_enums.patch: Vendorize better_enums header. 

 -- Michael Banck <mbanck@debian.org>  Sun, 06 Apr 2025 00:16:38 +0200

=== debian/control ===
Source: rdkit
Section: science
Priority: optional
Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
Uploaders: Michael Banck <mbanck@debian.org>,
           Andrius Merkys <merkys@debian.org>,
           Roland Mas <lolando@debian.org>,
Build-Depends: architecture-is-64-bit,
               architecture-is-little-endian,
               bison,
               catch2,
               cmake,
               debhelper-compat (= 13),
               dh-python,
               doxygen,
               flex,
               imagemagick,
               latexmk,
               libboost-dev,
               libboost-iostreams-dev,
               libboost-numpy-dev,
               libboost-program-options-dev,
               libboost-python-dev,
               libboost-regex-dev,
               libboost-system-dev,
               libboost-thread-dev,
               libcairo2-dev,
               libcoordgen-dev,
               libeigen3-dev,
               libfreetype-dev,
               libinchi-dev (>= 1.07.1+dfsg-2),
               libmaeparser-dev,
               librsvg2-bin,
               libsqlite3-dev,
               pandoc,
               postgresql-server-dev-all,
               python3-dev,
               python3-myst-parser,
               python3-numpy,
               python3-pandas,
               python3-pil | python3-imaging,
               python3-pytest,
               python3-recommonmark,
               python3-sphinx,
               python3-sqlalchemy,
               rapidjson-dev,
               tex-gyre,
               texlive-fonts-recommended,
               texlive-latex-base,
               texlive-latex-extra,
               texlive-latex-recommended
Standards-Version: 4.6.2
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/debichem-team/rdkit
Vcs-Git: https://salsa.debian.org/debichem-team/rdkit.git
Homepage: http://www.rdkit.org

Package: python3-rdkit
Section: python
Architecture: any
Depends: fonts-freefont-ttf,
         rdkit-data,
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Suggests: rdkit-doc
Provides: ${python3:Provides}
Description: Collection of cheminformatics and machine-learning software
 RDKit is a Python/C++ based cheminformatics and machine-learning software
 environment.  Features Include:
 .
  * Chemical reaction handling and transforms
  * Substructure searching with SMARTS
  * Canonical SMILES
  * Molecule-molecule alignment
  * Large number of molecular descriptors, including topological,
    compositional, EState, SlogP/SMR, VSA and Feature-map vectors
  * Fragmentation using RECAP rules
  * 2D coordinate generation and depiction, including constrained depiction
  * 3D coordinate generation using geometry embedding
  * UFF and MMFF94 forcefields
  * Chirality support, including calculation of (R/S) stereochemistry codes
  * 2D pharmacophore searching
  * Fingerprinting, including Daylight-like, atom pairs, topological
    torsions, Morgan algorithm and MACCS keys
  * Calculation of shape similarity
  * Multi-molecule maximum common substructure
  * Machine-learning via clustering and information theory algorithms
  * Gasteiger-Marsili partial charge calculation
 .
 File formats RDKit supports include MDL Mol, PDB, SDF, TDT, SMILES and RDKit
 binary format.

Package: rdkit-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}, ${shlibs:Depends}, libjs-jquery, libjs-underscore
Description: Collection of cheminformatics and machine-learning software (documentation)
 RDKit is a Python/C++ based cheminformatics and machine-learning software
 environment.
 .
 This package contains the documentation.

Package: rdkit-data
Architecture: all
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Collection of cheminformatics and machine-learning software (data files)
 RDKit is a Python/C++ based cheminformatics and machine-learning software
 environment.
 .
 This package contains data files.

Package: librdkit1t64
Provides: ${t64:Provides}
Replaces: librdkit1
Breaks: librdkit1 (<< ${source:Version}), coot (<< 1.1.15+dfsg-1)
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Collection of cheminformatics and machine-learning software (shared libraries)
 RDKit is a Python/C++ based cheminformatics and machine-learning software
 environment.  Features Include:
 .
  * Chemical reaction handling and transforms
  * Substructure searching with SMARTS
  * Canonical SMILES
  * Molecule-molecule alignment
  * Large number of molecular descriptors, including topological,
    compositional, EState, SlogP/SMR, VSA and Feature-map vectors
  * Fragmentation using RECAP rules
  * 2D coordinate generation and depiction, including constrained depiction
  * 3D coordinate generation using geometry embedding
  * UFF and MMFF94 forcefields
  * Chirality support, including calculation of (R/S) stereochemistry codes
  * 2D pharmacophore searching
  * Fingerprinting, including Daylight-like, atom pairs, topological
    torsions, Morgan algorithm and MACCS keys
  * Calculation of shape similarity
  * Multi-molecule maximum common substructure
  * Machine-learning via clustering and information theory algorithms
  * Gasteiger-Marsili partial charge calculation
 .
 File formats RDKit supports include MDL Mol, PDB, SDF, TDT, SMILES and RDKit
 binary format.
 .
 This package contains the shared libraries.

Package: librdkit-dev
Section: libdevel
Architecture: any
Depends: librdkit1t64 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: Collection of cheminformatics and machine-learning software (development files)
 RDKit is a Python/C++ based cheminformatics and machine-learning software
 environment.  Features Include:
 .
  * Chemical reaction handling and transforms
  * Substructure searching with SMARTS
  * Canonical SMILES
  * Molecule-molecule alignment
  * Large number of molecular descriptors, including topological,
    compositional, EState, SlogP/SMR, VSA and Feature-map vectors
  * Fragmentation using RECAP rules
  * 2D coordinate generation and depiction, including constrained depiction
  * 3D coordinate generation using geometry embedding
  * UFF and MMFF94 forcefields
  * Chirality support, including calculation of (R/S) stereochemistry codes
  * 2D pharmacophore searching
  * Fingerprinting, including Daylight-like, atom pairs, topological
    torsions, Morgan algorithm and MACCS keys
  * Calculation of shape similarity
  * Multi-molecule maximum common substructure
  * Machine-learning via clustering and information theory algorithms
  * Gasteiger-Marsili partial charge calculation
 .
 File formats RDKit supports include MDL Mol, PDB, SDF, TDT, SMILES and RDKit
 binary format.
 .
 This package contains the header files.

Package: postgresql-17-rdkit
Architecture: any
Section: database
Depends: ${misc:Depends}, ${shlibs:Depends}, postgresql-17
Description: Cheminformatics and machine-learning software (PostgreSQL Cartridge)
 RDKit is a Python/C++ based cheminformatics and machine-learning software
 environment.  Features Include:
 .
  * Chemical reaction handling and transforms
  * Substructure searching with SMARTS
  * Canonical SMILES
  * Molecule-molecule alignment
  * Large number of molecular descriptors, including topological,
    compositional, EState, SlogP/SMR, VSA and Feature-map vectors
  * Fragmentation using RECAP rules
  * 2D coordinate generation and depiction, including constrained depiction
  * 3D coordinate generation using geometry embedding
  * UFF and MMFF94 forcefields
  * Chirality support, including calculation of (R/S) stereochemistry codes
  * 2D pharmacophore searching
  * Fingerprinting, including Daylight-like, atom pairs, topological
    torsions, Morgan algorithm and MACCS keys
  * Calculation of shape similarity
  * Multi-molecule maximum common substructure
  * Machine-learning via clustering and information theory algorithms
  * Gasteiger-Marsili partial charge calculation
 .
 File formats RDKit supports include MDL Mol, PDB, SDF, TDT, SMILES and RDKit
 binary format.
 .
 This package contains the PostgreSQL extension.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export CPPFLAGS     := $(shell dpkg-buildflags --get CPPFLAGS)
export CFLAGS       := $(shell dpkg-buildflags --get CFLAGS) $(CPPFLAGS)
export CXXFLAGS     := $(shell dpkg-buildflags --get CXXFLAGS) $(CPPFLAGS)
export LDFLAGS      := $(shell dpkg-buildflags --get LDFLAGS)

export DOCDIR       := $(CURDIR)/debian/rdkit-doc/usr/share/doc/rdkit/

export RDBASE       := $(CURDIR)

PY3VERS = $(shell py3versions -v -d)
PY3 = $(shell which python$(PY3VERS))
export DEBTMP := $(CURDIR)/debian/tmp

DH_AUTO_CONFIGURE_OPTS := -DCMAKE_BUILD_TYPE=None -DCMAKE_SKIP_RPATH=ON \
                          -DRDK_INSTALL_INTREE=OFF -DRDK_INSTALL_STATIC_LIBS=OFF \
                          -DRDK_BUILD_THREADSAFE_SSS=ON -DRDK_BUILD_PYTHON_WRAPPERS=ON \
                          -DRDK_BUILD_INCHI_SUPPORT=ON \
                          -DRDK_OPTIMIZE_POPCNT=OFF -DRDK_USE_URF=OFF \
                          -DRDK_INSTALL_COMIC_FONTS=OFF \
                          -DRDK_BUILD_CAIRO_SUPPORT=ON \
                          -DRDK_BUILD_PUBCHEMSHAPE_SUPPORT=OFF \
                          -DRDK_BUILD_XYZ2MOL_SUPPORT=ON \
                          -DBoost_NO_BOOST_CMAKE=TRUE \
                          -DCMAKE_INSTALL_PREFIX=/usr \
                          -DCATCH_DIR=/usr/include/catch2 \
                          -DRDK_BUILD_PGSQL=ON \
                          -DRDK_PGSQL_STATIC=OFF \
                          -DPostgreSQL_CONFIG=/usr/bin/pg_config \
                          -DPostgreSQL_TYPE_INCLUDE_DIR="/usr/include/postgresql/17/server"

include /usr/share/postgresql-common/pgxs_debian_control.mk

%:
	dh $@ --with python3 --buildsystem=cmake

override_dh_auto_clean:
	find $(CURDIR) -name "*.pyc" | xargs rm -f
	$(RM) -r Projects/DbCLI/testData/bzr/ rdkit/Chem/inchi.py
	$(RM) -r Docs/Book/_build Code/docs rdkit/docs Code/doxygen_sqlite3.db
	$(RM) \
	Code/ForceField/MMFF/test_data/MMFF94_dative_min.sdf \
	Code/ForceField/MMFF/test_data/MMFF94_dative_min_from_SMILES.sdf \
	Code/ForceField/MMFF/test_data/MMFF94_hypervalent_min.sdf \
	Code/ForceField/MMFF/test_data/MMFF94_hypervalent_min_from_SMILES.sdf \
	Code/ForceField/MMFF/test_data/MMFF94_reference.log \
	Code/ForceField/MMFF/test_data/MMFF94s_reference.log \
	Code/ForceField/MMFF/test_data/testMMFFForceField.log \
	Code/GraphMol/Depictor/test_data/cis_trans_cpp.out.sdf \
	Code/GraphMol/Depictor/test_data/collisions.out.sdf \
	Code/GraphMol/Depictor/test_data/first_200.out.sdf \
	Code/GraphMol/Depictor/test_data/test1.out.sdf \
	Code/GraphMol/FileParsers/test_data/blah.sdf \
	Code/GraphMol/FileParsers/test_data/cdk2_stereo.sdf \
	Code/GraphMol/FileParsers/test_data/outNCI_few.sdf \
	Code/GraphMol/FileParsers/test_data/outNCI_few.tdt \
	Code/GraphMol/FileParsers/test_data/outNCI_first_200.props.sdf \
	Code/GraphMol/FileParsers/test_data/outSmiles.csv \
	Code/GraphMol/ForceFieldHelpers/UFF/test_data/Issue62.sdf \
	Code/GraphMol/MolAlign/test_data/ref_e2_pyCrippenO3A.sdf \
	Code/GraphMol/SLNParse/lex.yysln.cpp \
	Code/GraphMol/SLNParse/sln.tab.cpp \
	Code/GraphMol/SLNParse/sln.tab.hpp \
	Code/GraphMol/SmilesParse/lex.yysmarts.cpp \
	Code/GraphMol/SmilesParse/lex.yysmiles.cpp \
	Code/GraphMol/SmilesParse/smarts.tab.cpp \
	Code/GraphMol/SmilesParse/smarts.tab.hpp \
	Code/GraphMol/SmilesParse/smiles.tab.cpp \
	Code/GraphMol/SmilesParse/smiles.tab.hpp \
	Code/GraphMol/Wrap/test_data/outNCI_few.sdf \
	Code/GraphMol/Wrap/test_data/outSmiles.txt \
	Code/RDGeneral/versions.cpp \
	Docs/Book/Cartridge.rst \
	Docs/Book/Install.rst \
	Docs/Book/Overview.rst \
	rdkit/ML/Data/test_data/testgeneral.dat.pkl \
	rdkit/ML/Data/test_data/testquant.qdat.pkl
	$(RM) Code/RDGeneral/versions.h rdkit/sping/tests/testallps.ps
	dh_auto_clean
	$(RM) -rf $(CURDIR)/Code/PgSQL/rdkit/build-*

override_dh_auto_configure:
	dh_auto_configure -- $(DH_AUTO_CONFIGURE_OPTS) -DPYTHON_EXECUTABLE=$(PY3) ../
	for v in $$(pg_buildext supported-versions); do \
		(mkdir -p Code/PgSQL/rdkit/build-$$v && cd Code/PgSQL/rdkit/build-$$v && cmake -DPostgreSQL_CONFIG=/usr/lib/postgresql/$$v/bin/pg_config -DRDK_PGSQL_STATIC=OFF -DPostgreSQL_TYPE_INCLUDE_DIR="/usr/include/postgresql/$$v/server" -DCMAKE_VERBOSE_MAKEFILE=1 -DRDKit_CodeDir=../../../Code ../); \
	done

override_dh_auto_build:
	dh_auto_build
	for v in $$(pg_buildext supported-versions); do \
		(cd Code/PgSQL/rdkit/build-$$v && make || $$(cat ../../../../obj-*/Code/PgSQL/rdkit/CMakeFiles/rdkit.dir/link.txt | sed -e 's#\.\./\.\./#../../../../obj-*/Code/#g')); \
	done
	(cd $(CURDIR)/Code; doxygen doxygen/doxygen.config)
	(cd $(CURDIR)/Docs/Book; RDBASE=$(CURDIR) $(MAKE) html)
	(cd $(CURDIR)/Docs/Book; RDBASE=$(CURDIR) $(MAKE) latexpdf)

override_dh_auto_install:
	dh_auto_install

override_dh_install:
	mkdir -p $(DEBTMP)/usr/lib/python3
	mv $(DEBTMP)/usr/lib/python$(PY3VERS)/site-packages $(DEBTMP)/usr/lib/python3/dist-packages
	$(RM) -rf $(DEBTMP)/usr/lib/python$(PY3VERS)
	ln -sf /usr/share/fonts/truetype/freefont/FreeSans.ttf $(DEBTMP)/usr/lib/python3/dist-packages/rdkit/Chem/Draw/FreeSans.ttf
	dh_install -ppython3-rdkit /usr/lib/python3
	$(RM) -rf $(DEBTMP)/usr/lib/python3/dist-packages/rdkit/docs/
	$(RM) -rf $(DEBTMP)/usr/share/RDKit/Projects/__pycache__
	$(RM) -rf $(DEBTMP)/usr/share/RDKit/Projects/DbCLI/__pycache__
	dh_numpy3
	dh_install
	for v in $$(pg_buildext supported-versions); do \
		mkdir -p debian/postgresql-$$v-rdkit/usr/lib/postgresql/$$v/lib/ debian/postgresql-$$v-rdkit/usr/share/postgresql/$$v/extension/; \
		cp Code/PgSQL/rdkit/build-$$v/librdkit.so debian/postgresql-$$v-rdkit/usr/lib/postgresql/$$v/lib/rdkit.so; \
		cp Code/PgSQL/rdkit/build-$$v/rdkit*.sql debian/postgresql-$$v-rdkit/usr/share/postgresql/$$v/extension/; \
		cp Code/PgSQL/rdkit/build-$$v/update_sql/rdkit*.sql debian/postgresql-$$v-rdkit/usr/share/postgresql/$$v/extension/; \
		cp Code/PgSQL/rdkit/rdkit.control debian/postgresql-$$v-rdkit/usr/share/postgresql/$$v/extension/; \
	done
	mkdir -p $(DOCDIR)
	# cp $(CURDIR)/Docs/Book/_build/latex/RDKit.pdf $(DOCDIR)
	cp -a $(CURDIR)/Docs/Book/_build/html $(DOCDIR)
	ln -sf /usr/share/javascript/jquery/jquery.js $(DOCDIR)/html/cppapi/jquery.js
	ln -sf /usr/share/javascript/jquery/jquery.js $(DOCDIR)/html/_static/jquery.js
	ln -sf /usr/share/javascript/underscore/underscore.js $(DOCDIR)/html/_static/underscore.js

override_dh_missing:
	dh_missing --list-missing

override_dh_installchangelogs:
	dh_installchangelogs ReleaseNotes.md

override_dh_python3:
	dh_python3 -ppython3-rdkit
	dh_numpy3 -ppython3-rdkit

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
override_dh_auto_test:
	cp -r rdkit obj-*/
	find $(CURDIR) -name rdchem.so
	PYTHONPATH=$(wildcard $(CURDIR)/obj-*/):$(wildcard $(CURDIR)/obj-*/)/rdkit/Chem/ LD_LIBRARY_PATH="$(wildcard $(CURDIR)/obj-*/)/lib:$(LD_LIBRARY_PATH)" dh_auto_test
endif
